package com.arrival.mobility.telemetryd.presets;

import org.bytedeco.javacpp.annotation.*;
import org.bytedeco.javacpp.tools.*;

@Properties(
    target = "com.arrival.mobility.telemetryd",
    global = "com.arrival.mobility.telemetryd.global.Telemetryd",
    helper = "com.arrival.mobility.telemetryd.helper.TelemetrydHelper",
    value = {
            @Platform(
                    value = { "macosx-x86_64" },
                    compiler = "cpp11",
                    define = {"SHARED_PTR_NAMESPACE std", "UNIQUE_PTR_NAMESPACE std"},
                    include = {
                            "test_functions.h"
                    }
            )
    }
)
public class Telemetryd implements InfoMapper {

    @Override
    public void map(InfoMap infoMap) {
        infoMap.put(new Info().enumerate());
        infoMap.put(new Info("std::string_view").pointerTypes("@StdString String").define());
        infoMap.put(new Info("std::function<void(MyStreamstream)>").pointerTypes("MyStreamCallback"));
        infoMap.put(new Info("std::function<void(std::unique_ptr<MyStream>stream)>").pointerTypes("UniquePtrMyStreamCallback"));
        infoMap.put(new Info("std::function<void(boolsuccess)>").pointerTypes("BooleanCallback"));
    }
}
