# Telemetryd Javacpp Library

This repo contains adapters for [acvp-cloud-agent-cpp library](https://gitlab.arrival.co/cloud/acvp-cloud-agent-cpp) 
which were made with help of [javacpp library](https://github.com/bytedeco/javacpp).
Project structure was used from [javacpp-presets](https://github.com/bytedeco/javacpp-presets/tree/helloworld/helloworld)
Cpp library binaries for macos-x86_64 should be in cppbuild folder.
To compile cpp library automatically you should create cppbuild.sh and enable javacpp.cppbuild property in pom.xml.
To add support not only for other platforms please see [javacpp-presets](https://github.com/bytedeco/javacpp-presets/tree/helloworld/helloworld).

## Getting started

You need run `mvn clean install` in base dir and than run `mvn clean install` in platform dir.
After it you can use telemetryd-platform artefact in other project.

## How to make cpp library locally on macos
1. Сheckout somewhere https://gitlab.arrival.co/cloud/acvp-cloud-agent-cpp
2. git submodule init && git submodule update
3. use branch mac-build for both of them
4. install openssl
   brew install openssl
   brew upgrade openssl
   brew link --force openssl
   export LDFLAGS="-L/usr/local/opt/openssl@3/lib"                                                                        
   export CPPFLAGS="-I/usr/local/opt/openssl@3/include"
   export PKG_CONFIG_PATH="/usr/local/opt/openssl@3/lib/pkgconfig"
5. Install other dependencies https://gitlab.arrival.co/cloud/cpp-worker-docker-base/-/blob/master/Dockerfile
   by brew or from source from github
6. Export path:
   export LD_LIBRARY_PATH=/usr/local/lib:$LD_LIBRARY_PATH
   export LDFLAGS="$LDFLAGS -L/usr/local/opt/util-linux/lib"
   export CPPFLAGS="$CPPFLAGS -I/usr/local/opt/util-linux/include"
   export CPPFLAGS="$CPPFLAGS -I/usr/local/lib/log4cplus/include"
7. Build acvp-cloud-agent-cpp library
   mkdir cmake-build && cd cmake-build
   cmake -DCMAKE_BUILD_TYPE=Release -DBUILD_SHARED_LIBS=ON  ..
   cmake --build .