package com.arrival.mobility.telemetryd.helper;

import com.arrival.mobility.telemetryd.presets.Telemetryd;
import org.bytedeco.javacpp.FunctionPointer;
import org.bytedeco.javacpp.Loader;
import org.bytedeco.javacpp.annotation.ByVal;
import org.bytedeco.javacpp.annotation.Cast;
import org.bytedeco.javacpp.annotation.UniquePtr;


public class TelemetrydHelper extends Telemetryd {
    public static class BooleanCallback extends FunctionPointer {
        static { Loader.load(); }
        protected BooleanCallback() { allocate(); }
        private native void allocate();

        public native void call(boolean success);
    }

    public static class MyStreamCallback extends FunctionPointer {
        static {
            Loader.load();
        }

        protected MyStreamCallback() {
            allocate();
        }

        private native void allocate();

        public native void call(@ByVal com.arrival.mobility.telemetryd.MyStream stream);
    }

    //UNCOMMENT THIS TO REPRODUCE UNIQUE_PTR ERROR
    public static class UniquePtrMyStreamCallback extends FunctionPointer {
        static {
            Loader.load();
        }

        protected UniquePtrMyStreamCallback() {
            allocate();
        }

        private native void allocate();

        public native void call(@Cast({"", "std::unique_ptr<MyStream>", "std::unique_ptr<MyStream>&&"}) @UniquePtr com.arrival.mobility.telemetryd.MyStream stream);
    }
}
